/*-----------------------------------------------------------------------------

 2002, Jeff M Soft und Hardware GmbH, All Rights Reserved

-----------------------------------------------------------------------------*/

#include "Module.h"
#include "SEMod_struct.h"
#include "SEPin.h"
#include <assert.h>


#include <fcntl.h>     /* for _O_TEXT and _O_BINARY */
//#include <errno.h>     /* for EINVAL */
#include <sys\stat.h>  /* for _S_IWRITE */

#include <stdio.h> // files
#include <io.h> // filelenght ..

#include <string.h>
//#include <process.h>
//#include <wchar.h>


#define PN_1 0
#define PN_2 1
#define PN_3 2
#define PN_MIDI_OUT 3

#define SYSTEM_MSG		        0xF0
#define NOTE_OFF                0x80
#define NOTE_ON                 0x90




#define MAX_FILENAME_LENGTH 400

char path[MAX_FILENAME_LENGTH];
// char befehl[MAX_FILENAME_LENGTH];
char buffer[1000];
//sprintf(author,"s%","by ralph a. cronin FAKE MUSIC ");
   


bool memin1;
bool level1;

        


void Module::sub_process(long buffer_offset, long sampleFrames )
{   float *in1    = buffer_offset + input1_buffer;
    float *in2    = buffer_offset + input2_buffer;
    float *in3    = buffer_offset + input3_buffer;
    // float *out   = buffer_offset + output1_buffer;
    while(--sampleFrames >= 0) // sampleFrames = how many samples to process (can vary). repeat (loop) that many times
    {
		                memin1 = level1;
		if(*in1 > 0.2 ) level1 =  true; else level1 = false;

        if(level1 != memin1)//aktions
		{
		chan = 0;
		  if (level1) stat = NOTE_ON; else stat = NOTE_OFF;

          if(level1) b2 = (int)( *in2  * 128.0f);
          b3 = (int)( *in3  * 128.0f); 
		  if(b3 > 127) b3 = 127;
		  if(b3 < 0) b3 = 0;

          if(b2 > 127) b2 = 127;
		  if(b2 < 0) b2 = 0;


          this_midi = stat + chan + (b2 << 8) + (b3 << 16);
	      getPin(PN_MIDI_OUT)->TransmitMIDI( SampleClock(), this_midi );
		}
		// increment the pointers (move to next sample in buffers)
		in1++;
		in2++;
		in3++;
		// out++;
    }

 
}

// The core of a MIDI plugin
void Module::OnMidiData( unsigned long p_clock, unsigned long midi_msg, short pin_id)
{
	
}

Module::Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1) : SEModule_base(seaudioMaster, p_resvd1)
{
}

void Module::open()
{
	level1 = false;
	
    //err2=  fopen_s(&textfile,"F:\\DIAGNOSE.TXT","a+");
    //strcpy_s(text,4,"TEST");
	//if(err2 == 0) fwrite(text, sizeof(char),strlen(text), textfile);
	SEModule_base::open();
  
	// choose which function is used to process audio
	SET_PROCESS_FUNC(Module::sub_process);
}

Module::~Module()
{
	//_fcloseall();
}

// describe the module
bool Module::getModuleProperties (SEModuleProperties* properties)
{
   int j;

   j  = sprintf_s( buffer    ,1000, "%s\n", " ************************************" );
   j  = sprintf_s( buffer + j,1000, "%s\n", " * 2009 December in Tbingen GERMANY " );
   j += sprintf_s( buffer + j,1000, "%s\n", " *            FAKE MUSIC             " ); 
   j += sprintf_s( buffer + j,1000, "%s\n", " *         by ralph.a.cronin         " ); 
   j += sprintf_s( buffer + j,1000, "%s\n", " ************************************" );
   j += sprintf_s( buffer + j,1000, "%s\n", " * pitch 0-10 gives one midi note    " );
   j += sprintf_s( buffer + j,1000, "%s\n", " ************************************" );
   j += sprintf_s( buffer + j,1000, "%s\n", " *          enjoy SYNTHEDIT          " );
   j += sprintf_s( buffer + j,1000, "%s\n", " *        by Jeff Mc Clintock        " );
   j += sprintf_s( buffer + j,1000, "%s\n", " ************************************" );

   // MAXIS :
   // j += sprintf( buffer + j, "%s\n", " **************************************************************************************" );//120
   // j += sprintf( buffer + j, "%s\n", "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX" ); // = 54


	properties->name = "doNOTE";	// this is the name the end-user will see

	// return a uni+																																																			que string.
	// if posible include manufacturer and plugin identity
	// this is used internally by SE to identify the plug. No two plugs may have the same id.
	properties->id = "ralphs doNOTE1";

	// Info, may include Author, Web page whatever
	properties->about = buffer;//"by ralph a. cronin and Jeff M";
	return true;
}

// describe the pins (plugs)
bool Module::getPinProperties (long index, SEPinProperties* properties)
{
	switch( index )
	{
	
	case 0:
		properties->name				= "gate";
		properties->variable_address	= &input1_buffer;
		properties->direction			= DR_IN;
		properties->datatype			= DT_FSAMPLE;
		properties->default_value		= "0";
        properties->datatype_extra      = "10,0,10,0";
		break;
	case 1:
		properties->name				= "pitch";
		properties->variable_address	= &input2_buffer;
		properties->direction			= DR_IN;
		properties->datatype			= DT_FSAMPLE;
		properties->default_value		= "0";
        properties->datatype_extra      = "10,0,10,0";
		break;
    case 2:
		properties->name				= "velocity";
		properties->variable_address	= &input3_buffer;
		properties->direction			= DR_IN;
		properties->datatype			= DT_FSAMPLE;
		properties->default_value		= "0";
        properties->datatype_extra      = "10,0,10,0";
		break;
	case 3:
		properties->name				= "MIDI Out";
		properties->direction			= DR_OUT;
		properties->datatype			= DT_MIDI2;
		break;
	default:
		return false; // host will ask for plugs 0,1,2,3 etc. return false to signal when done
	};

	return true;
}



void Module::OnPlugStateChange(SEPin *pin)
{/*
    in_stat = getPin(PN_TEXT)->getStatus(); // bei 1 wechsel
    if(in_stat == ((state_type)1))
	{
	CallHost(seaudioMasterResolveFilename,PN_TEXT, MAX_FILENAME_LENGTH, (void *) full_path );
    //sprintf_s(text,400,"stat= %d \n",in_stat);
    //if(err2 == 0) fwrite(text, sizeof(char),strlen(text), textfile);
    sprintf_s(text,400,"%s\n",full_path);
	if(err2 == 0) fwrite(text, sizeof(char),strlen(text), textfile);
    //sprintf_s(text,400,"text_input= %s \n", text_input);
	//if(err2 == 0) fwrite(text, sizeof(char),strlen(text), textfile);
    wcscpy_s((wchar_t *)&smidi_play_name,strlen(full_path),(wchar_t *)&full_path);// copy name
    //loadarray();
    // err0 =  fopen_s(&smidi_play_file, smidi_play_name,"rb");
	isnew0 = true;
	*/
}// here we got new path if !


/*
    state_type out_stat = ST_STATIC;
	for (int i = 1; i <= 3; i++)
	{
	 in_stat = getPin(i)->getStatus();
	 if( in_stat > ST_STATIC ) 
	         {
				 out_stat = ST_RUN; 
				 break;
	         }
	}
*/

	// 'transmit' new output status to next module 'downstream'
	// getPin(PN_OUTPUT1)->TransmitStatusChange( SampleClock(), out_stat);// statt out_stat ralph



/*
void Module::loadarray()
{  
   //  LANGE ERMITTELN
   _sopen_s( &fh, smidi_play_name, _O_RDONLY,_O_RDONLY,_S_IREAD);         // open FILE "midiheaderless.smidi" C-style
    flang = (_filelength(fh)/sizeof (NOTES));                             // get lenght of file to share with two arrays.
   _close(fh);                                                            //      FILE closed
   // FREIMACHEN
      if(noten    != NULL) delete [] noten; // struct array lschen
   // RESERVIEREN
	  noten    = new NOTES [flang];taki = 0; // resize ARRAY reset ARRAYINDEX
    // EINLESEN
      fopen_s(&smidi_play_file, text_input , "r" );                       // FILEOPEN  r? rb?
      while(! feof(smidi_play_file))
      {
            fread(&note,sizeof(NOTES),1,smidi_play_file);                  // TIME_pc_clock
      noten[taki]= note;
            taki++;                                                        // next two    
	  };
      fclose(smidi_play_file);// THAT WAS THE MIDIFILE 
          last_take = --taki;                                              // EndMarker 
		  taki = 0;
}
*/
/*
void Module::loadarray()
{  
   //  LNGE ERMITTELN
   _sopen_s( &fh, text_input, _O_RDONLY,_O_RDONLY,_S_IREAD);  // open FILE "midiheaderless.smidi" C-style
    flang = (_filelength(fh)/sizeof (unsigned long)) / 2;   // get lenght of file to share with two arrays.
   _close(fh);                                                //      FILE closed

      if(tak_time != NULL) delete [] tak_time;                // delete if used before
      if(tak_midi != NULL) delete [] tak_midi;
 
      tak_time = new unsigned long [flang]; taki = 0;         // resize ARRAY reset ARRAYINDEX
      tak_midi = new unsigned long [flang];

      fopen_s(&stream, text_input , "r" );                    // FILEOPEN  ?rb
      while(! feof(stream))
      {
               fread(&pc,sizeof(unsigned long ),1,stream);        // TIME_pc_clock
      tak_time[taki]= pc;
               fread(&md,sizeof(unsigned long ),1,stream);        // MIDI_msg
      tak_midi[taki]= md;
                    taki++;                                      // next two    
	  }
      fclose(stream);// THAT WAS THE MIDIFILE 
          last_take = --taki;                                 // EndMarker
   done = 111; // int-Flag

    sprintf_s(text,400,"last_take= %d \n", last_take);
    if(err2 == 0) fwrite(text, sizeof(char),strlen(text), textfile);

}
*/

/*
errno_t err0 = -1;
FILE *smidi_play_file  = NULL;
char  smidi_play_name[MAX_FILENAME_LENGTH];
bool isnew0 = false;
*/


