#if !defined(_SEModule_h_inc_)
#define _SEModule_h_inc_

#define MAX_FILENAME_LENGTH 400
#include "SEModule_base.h"
#include <stdio.h> 

class Module : public SEModule_base
{
public:
	Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1);
	~Module();

	static bool getModuleProperties (SEModuleProperties* properties); 
	virtual bool getPinProperties (long index, SEPinProperties* properties);
	void SE_CALLING_CONVENTION sub_process(long buffer_offset, long sampleFrames );
	void OnPlugStateChange(SEPin *pin);
	virtual void OnMidiData( unsigned long p_clock, unsigned long midi_msg, short pin_id);
	void open();

    void diag(char * melde);
	void loadarray();

private:
    float *input1_buffer; // pointer to circular buffer of samples
	float *input2_buffer;
	
    int stat;// on off ...
    int chan;// 0 = channel 1
	int b2;//pitch     was = ( midi_msg / 0x100 ) & 0xff;
	int b3;//velocity  was = ( midi_msg / 0x10000 ) & 0xff;
    unsigned long this_midi;
	short loop;
	bool admin;

    char *text_input;



struct LL
{
char thisSEM[100];
};
struct BB
{
	char buffer[1000];
};

state_type in_stat;

char path[MAX_FILENAME_LENGTH];
char full_path[MAX_FILENAME_LENGTH];
char smidi_rec_name[MAX_FILENAME_LENGTH];
char smidi_play_name[MAX_FILENAME_LENGTH];
char text_filename[MAX_FILENAME_LENGTH];

FILE *smidi_rec_file;//  = NULL;
FILE *smidi_play_file;//  = NULL;
FILE *textfile;// = NULL;
FILE *stream;// = NULL;

char text[400];

errno_t err2;// = -1;
errno_t err0;// = -1;
errno_t err;// = -1;


//flags
bool didonce;// = false;
bool isnew0;// = false;
bool isnew;// = false;

int done;// = 0;

unsigned long flang, taki, last_take;
unsigned long pc , md;
unsigned long * tak_time;
unsigned long * tak_midi;
int fh;


unsigned long time1;
unsigned long midi;
unsigned long start_time;
unsigned long pause_time;
struct NOTES 
{  
   unsigned long r_time;
   unsigned long r_midi;
} note;

NOTES * noten;
bool got_one;// = false;
bool memin1;
bool level1;

bool canload;      
bool PLAY;
bool waspause;

};
#endif
