/*-----------------------------------------------------------------------------

 2002, Jeff M Soft und Hardware GmbH, All Rights Reserved

-----------------------------------------------------------------------------*/

#include "Module.h"
#include "E:\SDK2_SE_R\SEMod_struct.h"
#include "E:\SDK2_SE_R\SEPin.h"
#include <assert.h>


#include <fcntl.h>     /* for _O_TEXT and _O_BINARY */
#include <errno.h>     /* for EINVAL */
#include <sys\stat.h>  /* for _S_IWRITE */
#include <share.h>     /* for _SH_DENYNO */

//#include <sys/types.h>

#include <io.h>

#include <stdlib.h>
#include <string.h>
#include <process.h>
#include <wchar.h>
#include <math.h>

// float freq = 440.0f * pow(2.0f , (10.0f *(*pit - 0.5f))  );
void Module::sub_process(long buffer_offset, long sampleFrames )
{
	float *pitch   = buffer_offset + input1_buffer; 
	float *audio   = buffer_offset + output1_buffer;
    
	org_pitch = 0.5f; // AUFNAHME PITCH = 5

	if( oldpit != *pitch)
 	  {
	   f_take = pow(2.0f , (10.0f *(*pitch - org_pitch))  ) ;// 1.0f + (*pitch - org_pitch) * 10.0f ; // 5 ok     
       oldpit = *pitch;    		
	  }  

	while(--sampleFrames >= 0)
	{
     *audio = 0.0f;
        
      if (PLAY)
	  {
	   *audio = tak_float[(int)is_taki];//taki = (unsigned long) is_taki;
			                   is_taki = is_taki + f_take; // == taki++
						while (is_taki > last_take) is_taki -= last_take;
						   //if (is_taki < 0        ) is_taki = is_taki + last_take;
	  }
	 
	 audio++;
	}
	pitch += sampleFrames;	
}

// The core of a MIDI plugin
void Module::OnMidiData( unsigned long p_clock, unsigned long midi_msg, short pin_id)
{
 
}

Module::Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1) : SEModule_base(seaudioMaster, p_resvd1)
{
}

void Module::open()
{

err = -1;
err2 = -1;
swavfileout  = NULL;
textfile = NULL;
tak_float = NULL;


	SEModule_base::open();
	// choose which function is used to process audio
	SET_PROCESS_FUNC(Module::sub_process);
}

Module::~Module()
{
	if(err == 0)
	{
	  fclose(swavfileout);
	}

    if(err2 == 0)
	{
	  fclose(textfile);
	}
}

// describe the module
bool Module::getModuleProperties (SEModuleProperties* properties)
{
   LL dish;
   BB bish;
   sprintf_s(dish.thisSEM   ,100, "%s\n",  "SWAV_PLAYpitch2_M" );
   int j;

   j  = sprintf_s(  bish.buffer    ,1000, "%s\n", " ************************************" );
   j  = sprintf_s(  bish.buffer + j,1000, "%s\n", " * 2009 December in Tbingen GERMANY " );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *            FAKE MUSIC             " ); 
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *         by ralph.a.cronin         " ); 
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " ************************************" );
   j += sprintf_s(  bish.buffer + j,1000, "%s"  ,   dish.thisSEM );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " ************************************" );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *          enjoy SYNTHEDIT          " );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *        by Jeff Mc Clintock        " );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " ************************************" );

   // MAXIS :
   // j += sprintf( buffer + j, "%s\n", " **************************************************************************************" );//120
   // j += sprintf( buffer + j, "%s\n", "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX" ); // = 54


	properties->name = dish.thisSEM;	// this is the name the end-user will see

	// return a uni+																																																			que string.
	// if posible include manufacturer and plugin identity
	// this is used internally by SE to identify the plug. No two plugs may have the same id.
	properties->id = dish.thisSEM;

	// Info, may include Author, Web page whatever
	properties->about =  bish.buffer;//"by ralph a. cronin and Jeff M";
	return true;

}

// describe the pins (plugs)
bool Module::getPinProperties (long index, SEPinProperties* properties)
{
	switch( index )
	{
    case 0:	
		properties->name				= "pitch";
		properties->variable_address	= &input1_buffer;
		properties->direction			= DR_IN;
		properties->datatype			= DT_FSAMPLE;
		break;
	case 1:
		properties->name                = "FILE";
        properties->variable_address    = &text_input;
        properties->direction           = DR_IN;
        properties->datatype            = DT_TEXT; 
        properties->flags               = IO_FILENAME;
        properties->datatype_extra      ="swav"; // file extension
        break;
	case 2:
		properties->name				= "on D: DIAGNOSE.TXT";
		properties->variable_address	= &admin;
		properties->direction			= DR_PARAMETER;
        properties->datatype			= DT_BOOL;
		properties->default_value		= "false";
		break;
    case 3:	
		properties->name				= "AUDIO";
		properties->variable_address	= &output1_buffer;
		properties->direction			= DR_OUT;
		properties->datatype			= DT_FSAMPLE;
		break;
	default:
		return false; // host will ask for plugs 0,1,2,3 etc. return false to signal when done
	};

	return true;
}


void Module::diag(char * melde)
{
 err2= fopen_s(&textfile,"D:\\DIAGNOSE.TXT","a+");
 if(err2 == 0)
 {
	 fwrite(melde, sizeof(char),strlen(melde), textfile);
     fclose(textfile);
 }
}


void Module::doaway()
{
     if(err == 0)
	 {
		 fclose(swavfileout);
	 }
     _unlink(swav_filename);
	 last_take = 0;
     err =  fopen_s(&swavfileout, swav_filename,"a+b");
}


void Module::OnPlugStateChange(SEPin *pin)
{ 
	in_stat = getPin(PN_FILE)->getStatus(); // bei 1 wechsel
    if(in_stat == ((state_type)1))
	{
	  CallHost(seaudioMasterResolveFilename,PN_FILE, MAX_FILENAME_LENGTH, (void *) full_path );
	  if(admin)
	  {
       sprintf_s(text,400,"%s %s\n","SWAV_PLAYpitch2_M",full_path);diag(text);
	  }
	  wcscpy_s((wchar_t *)&swav_filename,strlen(full_path),(wchar_t *)&full_path);// copy name 
      PLAY = false;
	  loadArray();
	}
    getPin(PN_OUT)->TransmitStatusChange(SampleClock(),ST_RUN);
}



void Module::loadArray()
{
 if(err == 0) fclose(swavfileout);

 err =  fopen_s(&swavfileout, swav_filename,"r+b"); // LESEN

 if(err == 0)
 {
      float ch;
      int filehandle = _fileno(swavfileout);
      flang = _filelength(filehandle);
	  flang = flang / sizeof(float);
      flang++;
  
      if(tak_float != NULL) delete [] tak_float;
         tak_float = new float [flang];
      	
	  int taki = 0; 
      while(! feof(swavfileout))
      {
                fread(&ch,sizeof(float ),1,swavfileout);     
      tak_float[taki]= ch;
                taki++;                                      
	  }
	  
      fclose(swavfileout);// THAT WAS THE MIDIFILE 
          last_take = --taki;                                 // EndMarker
        if(last_take > 0) 
		{
			PLAY = true;
			is_taki = 0;
		}
        else 
		{
			PLAY = false;
			
		}
 }
}




