/*-----------------------------------------------------------------------------

 2002, Jeff M Soft und Hardware GmbH, All Rights Reserved

-----------------------------------------------------------------------------*/

#include "Module.h"
#include "E:\SDK2_SE_R\SEMod_struct.h"
#include "E:\SDK2_SE_R\SEPin.h"
#include <assert.h>


#include <fcntl.h>     /* for _O_TEXT and _O_BINARY */
#include <errno.h>     /* for EINVAL */
#include <sys\stat.h>  /* for _S_IWRITE */
#include <share.h>     /* for _SH_DENYNO */

//#include <sys/types.h>
#include <stdio.h> // files
#include <io.h>

#include <stdlib.h>
#include <string.h>
#include <process.h>
#include <wchar.h>

void Module::sub_process(long buffer_offset, long sampleFrames )
{
	
	float *in    = buffer_offset + input1_buffer;
	float *rec   = buffer_offset + input2_buffer; 
	float *play  = buffer_offset + input3_buffer; 
	float *del   = buffer_offset + input4_buffer; 
	float *conti   = buffer_offset + output1_buffer;
	float *audio   = buffer_offset + output2_buffer;

	while(--sampleFrames >= 0)
	{
		if (*del  > 0.0) DEL = true; else {DEL = false; wasok = true;}
		
		if((DEL)&&(wasok))
		{
			wasok = false;
		    doaway();
		}

		if (*rec  > 0.0)
		{
			REC  = true; 
			wasrec = true;
			didload = false;
		} 
		else
		{
			REC = false;
			count = 0;
			nullrise =false;
		}
	    
		if (*play > 0.0)
		{
		    if(didload == false) 
			{
				loadArray();
				didload = true;
			}
			if(last_take > 0) PLAY = true;
		}	
		else 
		{
			PLAY = false;
			*audio = 0.0f;
		}
		
        if ((PLAY)&&(REC == false))
		{
			if(wasrec == true)
			{
			 wasrec = false;
			 loadArray();
			}
		 
			*audio = tak_float[taki];
                               taki++;
							          playTO = (unsigned long) playto; 
		   	               if (taki > playTO)    taki = 0; 
						   if (taki > last_take) taki = 0;
		 
		}
        if((*in >= 0.0f)&&(lf < 0.0f)) //rec from rise
		{
			nullrise = true;
		} 

		if((REC)&&(nullrise))
		{
         fwrite(in, sizeof(float),1, swavfileout);
		 count++;
		*conti   = (float)(count);
		}
		lf = *in;
		
	 in++;
	 rec++;
	 play++;
	 del++;
	 conti++;
	 audio++;
	}	
}

// The core of a MIDI plugin
void Module::OnMidiData( unsigned long p_clock, unsigned long midi_msg, short pin_id)
{
 
}

Module::Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1) : SEModule_base(seaudioMaster, p_resvd1)
{
}

void Module::open()
{

err = -1;
err2 = -1;
swavfileout  = NULL;
textfile = NULL;
tak_float = NULL;

	SEModule_base::open();
	// choose which function is used to process audio
	SET_PROCESS_FUNC(Module::sub_process);
}

Module::~Module()
{
	if(err == 0)
	{
	  fclose(swavfileout);
	}

    if(err2 == 0)
	{
	  fclose(textfile);
	}
}

// describe the module
bool Module::getModuleProperties (SEModuleProperties* properties)
{
LL dish;
   BB bish;
   sprintf_s(dish.thisSEM   ,100, "%s\n","SWAV_REC_PLAY_M" );
   int j;

   j  = sprintf_s(  bish.buffer    ,1000, "%s\n", " ************************************" );
   j  = sprintf_s(  bish.buffer + j,1000, "%s\n", " * 2009 December in Tbingen GERMANY " );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *            FAKE MUSIC             " ); 
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *         by ralph.a.cronin         " ); 
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " ************************************" );
   j += sprintf_s(  bish.buffer + j,1000, "%s"  ,   dish.thisSEM );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *    RECORDER for SMIDI Files       " );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " ************************************" );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *          enjoy SYNTHEDIT          " );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *        by Jeff Mc Clintock        " );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " ************************************" );

   // MAXIS :
   // j += sprintf( buffer + j, "%s\n", " **************************************************************************************" );//120
   // j += sprintf( buffer + j, "%s\n", "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX" ); // = 54


	properties->name = dish.thisSEM;	// this is the name the end-user will see

	// return a uni+																																																			que string.
	// if posible include manufacturer and plugin identity
	// this is used internally by SE to identify the plug. No two plugs may have the same id.
	properties->id = dish.thisSEM;

	// Info, may include Author, Web page whatever
	properties->about =  bish.buffer;//"by ralph a. cronin and Jeff M";
	return true;

}

// describe the pins (plugs)
bool Module::getPinProperties (long index, SEPinProperties* properties)
{
	switch( index )
	{
    case 0:	
		properties->name				= "signal";
		properties->variable_address	= &input1_buffer;
		properties->direction			= DR_IN;
		properties->datatype			= DT_FSAMPLE;
		break;
    case 1:	
		properties->name				= "REC";
		properties->variable_address	= &input2_buffer;
		properties->direction			= DR_IN;
		properties->datatype			= DT_FSAMPLE;
		properties->default_value		= "0";
        properties->datatype_extra      = "10,0,10,0";
		break;
    case 2:	
		properties->name				= "PLAY";
		properties->variable_address	= &input3_buffer;
		properties->direction			= DR_IN;
		properties->datatype			= DT_FSAMPLE;
		properties->default_value		= "0";
        properties->datatype_extra      = "10,0,10,0";
		break; 
   case 3:
        properties->name				= "delete FILE";
		properties->variable_address	= &input4_buffer;
		properties->direction			= DR_IN;
		properties->datatype			= DT_FSAMPLE;
		properties->default_value		= "0";
		break;
	case 4:
		properties->name				= "play to";
		properties->variable_address	= &playto;
		properties->datatype_extra		= "range 0,32767";
		properties->default_value		= "100";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
	case 5:
		properties->name                = "FILE";
        properties->variable_address    = &text_input;
        properties->direction           = DR_IN;
        properties->datatype            = DT_TEXT; 
        properties->flags               = IO_FILENAME;
        properties->datatype_extra      ="swav"; // file extension
        break;
	case 6:
		properties->name				= "on D: DIAGNOSE.TXT";
		properties->variable_address	= &admin;
		properties->direction			= DR_PARAMETER;
        properties->datatype			= DT_BOOL;
		properties->default_value		= "false";
		break;
    case 7:	
		properties->name				= "recSAMPS";
		properties->variable_address	= &output1_buffer;
		properties->direction			= DR_OUT;
		properties->datatype			= DT_FSAMPLE;
		break;
    case 8:	
		properties->name				= "AUDIO";
		properties->variable_address	= &output2_buffer;
		properties->direction			= DR_OUT;
		properties->datatype			= DT_FSAMPLE;
		break;
	default:
		return false; // host will ask for plugs 0,1,2,3 etc. return false to signal when done
	};

	return true;
}

void Module::diag(char * melde)
{
 err2= fopen_s(&textfile,"D:\\DIAGNOSE.TXT","a+");
 if(err2 == 0)
 {
	 fwrite(melde, sizeof(char),strlen(melde), textfile);
     fclose(textfile);
 }
}

void Module::doaway()
{
     if(err == 0)
	 {
		 fclose(swavfileout);
	 }
     _unlink(swav_filename);
	 last_take = 0;
     err =  fopen_s(&swavfileout, swav_filename,"a+b");
}

void Module::OnPlugStateChange(SEPin *pin)
{ 
	in_stat = getPin(PN_FILE)->getStatus(); // bei 1 wechsel
    if(in_stat == ((state_type)1))
	{
	  CallHost(seaudioMasterResolveFilename,PN_FILE, MAX_FILENAME_LENGTH, (void *) full_path );
	  if(admin)
	  {
       sprintf_s(text,400,"%s %s\n",thisSEM,full_path);diag(text);
	  }
	  wcscpy_s((wchar_t *)&swav_filename,strlen(full_path),(wchar_t *)&full_path);// copy name 
	  loadArray();
	}
    getPin(PN_OUT)->TransmitStatusChange(SampleClock(),ST_RUN);
	getPin(PN_COUNT)->TransmitStatusChange(SampleClock(),ST_RUN);
}

void Module::loadArray()
{
 if(err == 0) fclose(swavfileout);

 err =  fopen_s(&swavfileout, swav_filename,"r+b"); // LESEN

 if(err == 0)
 {
      float ch;
      int filehandle = _fileno(swavfileout);
      flang = _filelength(filehandle);
	  flang = flang / sizeof(float);
      flang++;
  
      if(tak_float != NULL) delete [] tak_float;
         tak_float = new float [flang];
      	
	  taki = 0; 
      while(! feof(swavfileout))
      {
                fread(&ch,sizeof(float ),1,swavfileout);     
      tak_float[taki]= ch;
                taki++;                                      
	  }
	  
      fclose(swavfileout);// THAT WAS THE MIDIFILE 
          last_take = --taki;                                 // EndMarker
          taki = 0; 
 }

 err =  fopen_s(&swavfileout, swav_filename,"a+b"); // fr write
}




